/*******************************************************************
  *
  * Copyright (C) Mellanox Technologies Ltd. 2001-2011.  ALL RIGHTS RESERVED.
  *
  * This software product is a proprietary product of Mellanox Technologies Ltd.
  * (the "Company") and all right, title, and interest in and to the software product,
  * including all associated intellectual property rights, are and shall
  * remain exclusively with the Company.
  *
  * This software product is governed by the End User License Agreement
  * provided with the software product.
  *
  *******************************************************************/

#ifndef __CPLD_IFC_H__
#define __CPLD_IFC_H__

#define CPLD_JTAG_RC_FAIL   -1
#define CPLD_JTAG_RC_OK     0

#if defined(__i386__) || defined(__x86_64__)
#define CPLD_GPIO_TCK   56
#define CPLD_GPIO_TMS   24

#define CPLD_GPIO_TDI0  11
#define CPLD_GPIO_TDO0  57
/* On x86 these are same as 1st set */
#define CPLD_GPIO_TDI1  11  
#define CPLD_GPIO_TDO1  57
#else
/* There are 2 different sets of pins that is used for JTAG simulation.
   Set 0 (defult):  TDO - pin 28 & TDI - pin 29. It's used in IBM blade.
   Set 1:           TDI - pin 28 & TDO - pin 29. It's used on Jackal. */
#define CPLD_GPIO_TCK   30
#define CPLD_GPIO_TMS   27

#define CPLD_GPIO_TDI0  29
#define CPLD_GPIO_TDO0  28
  
#define CPLD_GPIO_TDI1  28  
#define CPLD_GPIO_TDO1  29 
#endif

int cpld_jtag_gpio_write(int fd, int tms, int tdi, int tck);
int cpld_jtag_gpio_read(int fd);
int cpld_jtag_io_operation(int fd, int tms, int tdi, int tck);
int cpld_jtag_open(char* path, int jtag_enable, int cpld);
void cpld_jtag_close(int fd, int cpld);

#endif
