/*******************************************************************
  *
  * Copyright (C) Mellanox Technologies Ltd. 2001-2011.  ALL RIGHTS RESERVED.
  *
  * This software product is a proprietary product of Mellanox Technologies Ltd.
  * (the "Company") and all right, title, and interest in and to the software product,
  * including all associated intellectual property rights, are and shall
  * remain exclusively with the Company.
  *
  * This software product is governed by the End User License Agreement
  * provided with the software product.
  *
  *******************************************************************/

#ifndef __CPLD_IFC_H__
#define __CPLD_IFC_H__

#include "sx/sxd/sxd_dpt.h"
#include <sx/sxd/kernel_user.h>
#include <sx/sxd/sxd_access_register.h>
#include <logger.h>

#define CPLD_JTAG_RC_FAIL   -1
#define CPLD_JTAG_RC_OK     0

#define N   1
#define TMS_OFFSET 0
#define TDI_OFFSET   1
#define TDO_OFFSET 3
#define CMD_DISABLE  0x0
#define CMD_ENABLE   0x1
#define CMD_ACCESS   0x2

#ifdef  CPLD_JAMDPT_DEBUG
#define CPLD_LOG_DBG(format, args...)  {printf("CPLD DBG: " format, ## args);}
#else
#define CPLD_LOG_DBG(format, args...)   ;
#endif

void cpld_jtag_delay(long microseconds);
int cpld_jtag_dpt_io_operation(int tms, int tdi, int read_tdo, int* tdo);
int cpld_jtag_dpt_open(void);
void cpld_jtag_dpt_close(void);

#endif
